// Copyright (c) 2016, Dart Gaming authors.  Please see the AUTHORS file
// for details. All rights reserved. Use of this source code is governed by a
// BSD-style license that can be found in the LICENSE file.

import 'package:gamepad/gamepad.dart';
import 'package:gamepad/drivers/virtual.dart';
import 'package:test/test.dart';

void main() {
  group('$TriggerDirection', () {
    _SimpleVirtualAxes axes;

    setUp(() => axes = new _SimpleVirtualAxes());

    test('should trigger "up"', () async {
      axes.triggerUp();
      expect(await axes.first, const AxesState.up());
    });

    test('should trigger "right"', () async {
      axes.triggerRight();
      expect(await axes.first, const AxesState.right());
    });

    test('should trigger "down"', () async {
      axes.triggerDown();
      expect(await axes.first, const AxesState.down());
    });

    test('should trigger "left"', () async {
      axes.triggerLeft();
      expect(await axes.first, const AxesState.left());
    });
  });
}

class _SimpleVirtualAxes = VirtualAxes with TriggerDirection;
